.586
.model flat, stdcall

include Windows.inc
include macros.def
include Kernel32.inc
include User32.inc
include GDI32.inc
include comctl32.inc
include advapi32.inc

includelib Kernel32.lib
includelib User32.lib
includelib GDI32.lib
includelib comctl32.lib
includelib advapi32.lib

comment		*

	Physical Memory Editor by The Dude of Dudes

	Uses my MemPhys driver to alter page table entries of the running
	process to map in views of any physical memory page.

		*

;=========================================
;======== Includes From NtDDK ===========
;=========================================

CTL_CODE MACRO DeviceType:=<0>, Function:=<0>, Method:=<0>, Access:=<0>
	EXITM %(((DeviceType) SHL 16) OR ((Access) SHL 14) OR ((Function) SHL 2) OR (Method))
ENDM

FILE_DEVICE_UNKNOWN             equ 22h
METHOD_BUFFERED                 equ 0
FILE_READ_DATA				equ 0001
FILE_WRITE_DATA				equ 0002

;==== User Control Values ====

	GETPHYS = 800h
	CHANGEPTE = 801h


;==== Control Code Definitions =====

	IOCTL_GETPHYS	equ CTL_CODE(FILE_DEVICE_UNKNOWN, GETPHYS, METHOD_BUFFERED, \
		FILE_READ_DATA or FILE_WRITE_DATA)

	IOCTL_CHANGEPTE	 equ CTL_CODE(FILE_DEVICE_UNKNOWN, CHANGEPTE, METHOD_BUFFERED, \
		FILE_READ_DATA or FILE_WRITE_DATA)

VtoP struct
	Virtual		dd	?
	Physical	dd	?
VtoP ends


ColorRef macro R, G, B
	local Color
	Color textequ %((B shl 16) or (G shl 8) or R)
	exitm Color
endm

.data?
align 4
;===============================
;       Global Variables 
;===============================
	MemBuffer		db	4096	dup	(?)
	hDialog		dd	?
	hListView	dd	?
	hVEdit		dd	?
	hPEdit		dd	?
	hVRadio		dd	?
	hPRadio		dd	?
	hRead		dd	?
	hWrite		dd	?
	hEditEdit	dd	?
	hMemPhys	dd	?
	pOldListViewProc	dd	?
	pOldEditProc		dd	?
	pOldDialogProc		dd	?
	pHeap		dd	?
	FlashSubItem	dd	?
	ItemToFlash	dd	?
	SubItemToFlash	dd	?
	pMemtoEdit	dd	?
	TextBuffer		db	256	dup	(?)

	NewPTE		VtoP	<?>
	OldPTE		VtoP	<?>

;===============================
;       Static Variables 
;===============================
	
	IDD_DIALOG   =                                  100
	IDD_DIALOGEDIT =				101
	IDRB_Virtual =					3001
	IDRB_Physical = 				3000
	IDC_ListView  =                                 3003
	IDC_VirtEdit  =                                 3006
	IDC_PhysEdit  =                                 3007
	IDB_READ      =     				  1
	IDB_WRITE     =     				  2
	IDC_EditEdit  =					5002
	IDB_OK	      =					5000
	IDB_CANCEL    = 				5001

	WM_TEXTREADY = WM_USER+30000

	FlashColor = ColorRef (180,180,180)
	UnFlashColor = ColorRef (255,255,255)
	Rows = 256		;256 rows of 16 bytes = 4k / 1page
	Columns = 17		;1 for address - 16 for 4 dwords
	ColumnWidth = 30
	InputBarHeight = 20
.code
;===========================
;	Prototypes
;===========================

	WinMain			proto, :dword, :dword, :dword, :dword
	DlgProc 		proto, :dword, :dword, :dword, :dword
	SubClassListView 	proto, :dword, :dword, :dword, :dword
	SubclassEdit		proto, :dword, :dword, :dword, :dword
	SubClassDialog		proto, :dword, :dword, :dword, :dword
	MakeColumn 		proto, :dword, :dword, :dword
	CreateList 		proto, :dword, :dword, :dword
	FillList		proto, :dword, :dword, :dword, :dword, :dword
	MapAndRead		proto
	MapAndWrite		proto
	EditMemory		proto, :dword
	DlgProc2 		proto, :dword, :dword, :dword, :dword
	htodw			proto, :dword
	InstallDriver		proto
	RemoveDriver		proto

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	EntryPoint proc	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

local hInstance:	dword
local lpCmdLine:	dword
local cmctlex:		INITCOMMONCONTROLSEX 


	mov cmctlex.dwSize, sizeof cmctlex
	mov cmctlex.dwICC, ICC_LISTVIEW_CLASSES
	invoke InitCommonControlsEx, addr cmctlex

	invoke GetModuleHandle, NULL	
	mov hInstance, eax

	invoke GetCommandLine
	mov lpCmdLine, eax

	invoke WinMain, hInstance, NULL, lpCmdLine, SW_SHOW
	invoke ExitProcess, eax

EntryPoint endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WinMain proc, hInstance: dword, hPrevInstance: dword, lpCmdLine: dword, nCmdShow: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	
	invoke InstallDriver
	.if eax == -1	;error, memphys did not start
		ret
	.endif
	;--- open handle to driver ---
	invoke CreateFile, SADD ("\\.\MemPhys"), GENERIC_READ or \
	   GENERIC_WRITE, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	mov hMemPhys, eax

	invoke GetProcessHeap
	mov pHeap, eax		;use heap page table entries to map memory

	invoke DialogBoxParam, hInstance, IDD_DIALOG, NULL, addr DlgProc, NULL

	invoke CloseHandle, hMemPhys
	invoke RemoveDriver
	ret

WinMain endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DlgProc proc, hWnd: dword, uMsg: dword, wParam: dword, lParam: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	temp:		dword
	local	BytesRet:	dword

	.if uMsg == WM_INITDIALOG

		mov eax, hWnd
		mov hDialog, eax
		;---- Set Global Flags ----
		mov FlashSubItem, TRUE	;Subitems flash when cursor is over them

		;---- Subclass Edit Controls ----
		invoke GetDlgItem, hWnd, IDC_VirtEdit
		mov hVEdit, eax
		invoke SetWindowLong, hVEdit, GWL_WNDPROC, addr SubclassEdit
		mov pOldEditProc, eax

		invoke GetDlgItem, hWnd, IDC_PhysEdit
		mov hPEdit, eax
		invoke SetWindowLong, hPEdit, GWL_WNDPROC, addr SubclassEdit
			

		;---- Subclass ListView ----
		invoke GetDlgItem, hWnd, IDC_ListView
		mov hListView, eax
		invoke SetWindowLong, hListView, GWL_WNDPROC, addr SubClassListView
		mov pOldListViewProc, eax
	
		;---- Subclass This DialogBox ----
		invoke SetWindowLong, hWnd, GWL_WNDPROC, addr SubClassDialog
		mov pOldDialogProc, eax

		;---- Get Handles to Button Controls ----
		invoke GetDlgItem, hWnd, IDB_READ
		mov hRead, eax
		invoke GetDlgItem, hWnd, IDB_WRITE
		mov hWrite, eax
		invoke GetDlgItem, hWnd, IDRB_Virtual
		mov hVRadio, eax
		invoke GetDlgItem, hWnd, IDRB_Physical
		mov hPRadio, eax

		;---- Set Controls ----
		invoke EnableWindow, hWrite, FALSE
		invoke SendMessage, hVRadio, BM_SETCHECK , BST_CHECKED, 0
		invoke SendMessage, hPRadio, BM_SETCHECK , BST_UNCHECKED, 0

		invoke CreateList, Rows, Columns, ColumnWidth
		invoke FillList, 0, 0, Rows, Columns, TRUE	;fill with --'s

		mov eax, FALSE	
		ret
		

	.elseif uMsg == WM_CLOSE
		invoke EndDialog, hWnd, NULL
		mov eax, TRUE
		ret

	.elseif uMsg == WM_COMMAND
	 
	 mov eax, wParam	

		.if ax == IDB_READ

			invoke SendMessage, hVRadio, BM_GETCHECK, 0, 0

		    .if eax == BST_CHECKED	

		;---- Virtual Address is Selected ----
			invoke GetWindowText, hVEdit, addr TextBuffer, 256
			pushad
			invoke htodw, addr TextBuffer
			and eax, 0fffff000h	;round down to page boundary
			mov NewPTE.Virtual, eax
			popad
			
			;---- Get physical address  ----	
			invoke DeviceIoControl, hMemPhys, IOCTL_GETPHYS, addr NewPTE.Virtual, 4, \
			 addr NewPTE.Physical, 4, addr BytesRet, NULL	

			;---- PTE exists for Virtual address ----
			.if NewPTE.Physical	
				mov eax, NewPTE.Physical
				and eax, 0fffff000h
				mov NewPTE.Physical, eax	
				invoke wsprintf, addr TextBuffer, SADD ("%08X"), NewPTE.Physical
				invoke SetWindowText, hPEdit, addr TextBuffer
	
				;--- map phys address to Process Heap ---
				mov eax, pHeap
				mov NewPTE.Virtual, eax
				invoke MapAndRead

			;---- No PTE exists for specified address (not allocated by windows) ----
			.else				
				mov TextBuffer, 0
				invoke SetWindowText, hPEdit, addr TextBuffer
				invoke FillList, 0, 0, Rows, Columns, TRUE	;fill with --'s
				invoke EnableWindow, hWrite, FALSE
			.endif
 
			mov eax, 0
			ret

		    .else
		;---- Physical Address is Selected ----
			mov TextBuffer, 0
			invoke SetWindowText, hVEdit, addr TextBuffer
			invoke GetWindowText, hPEdit, addr TextBuffer, 256
			pushad
			invoke htodw, addr TextBuffer
			and eax, 0fffff000h	;round down to page boundary
			mov NewPTE.Physical, eax	;use specified phys address
			popad
			mov eax, pHeap
			mov NewPTE.Virtual, eax		;map to Process Heap

			invoke MapAndRead

			mov eax, 0
			ret
		    .endif

		.elseif ax == IDB_WRITE

			invoke wsprintf, addr TextBuffer, SADD ("%08X"), NewPTE.Physical
			invoke SetWindowText, hPEdit, addr TextBuffer
			mov TextBuffer, 0
			invoke SetWindowText, hVEdit, addr TextBuffer
			invoke MapAndWrite

			mov eax, 0
			ret

		.endif

	.endif

	mov eax, FALSE
	ret

DlgProc endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SubClassListView proc, hWnd: dword, uMsg: dword, wParam: dword, lParam: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	lvhit:		LVHITTESTINFO
	local 	mevent:		TRACKMOUSEEVENT

   .if FlashSubItem == TRUE	;subitems are flashable

	.if uMsg == WM_MOUSEMOVE

		mov eax, lParam
		movzx ecx, ax		;x
		shr eax, 16		;y
		mov lvhit.pt.x, ecx
		mov lvhit.pt.y, eax
		invoke SendMessage, hListView, LVM_SUBITEMHITTEST, 0, addr lvhit
	;--- Check if cursor is over subitem, not address or ASCII dump ----
		  .if (eax != -1) && (lvhit.iSubItem > 1) && (lvhit.iSubItem <= Columns)
			mov eax, lvhit.iItem
			mov ecx, lvhit.iSubItem
			mov ItemToFlash, eax
			mov SubItemToFlash, ecx	;row and subitem to flash

		;--- Generate WM_MOUSELEAVE when cursor leaves client area ---
			mov mevent.cbSize, sizeof mevent
			mov mevent.dwFlags, TME_LEAVE
			mov eax, hWnd
			mov mevent.hwndTrack, eax
			invoke TrackMouseEvent, addr mevent

			invoke InvalidateRect, hListView, 0, FALSE
			
		 .else
			mov ItemToFlash, 0
			mov SubItemToFlash, 0	;dont flash any subitem
			invoke InvalidateRect, hListView, 0, FALSE
		  .endif
	.elseif uMsg == WM_MOUSELEAVE
		mov ItemToFlash, 0
		mov SubItemToFlash, 0	;dont flash any subitem
		invoke InvalidateRect, hListView, 0, FALSE
	
	.elseif uMsg == WM_LBUTTONDBLCLK

		.if SubItemToFlash

		invoke IsWindowEnabled, hWrite
		  .if eax
		     ;offset = (ItemToFlash * 16) + (SubItemToFlash - 2)
			mov eax, ItemToFlash
			shl eax, 4		; * 16
			add eax, SubItemToFlash
			add eax, -2			; - 2
			add eax, offset MemBuffer
			invoke EditMemory, eax
			
		  .endif
		.endif
		
	.endif

   .endif	

        invoke CallWindowProc, pOldListViewProc, hWnd, uMsg, wParam, lParam
	ret

SubClassListView endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SubclassEdit proc, hWnd: dword, uMsg: dword, wParam: dword, lParam: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	.if uMsg == WM_CHAR
		
		.if (wParam >= 61h) && (wParam <= 66h)
			and wParam, 11011111b
			jmp Break 

		.elseif (wParam >= 41h) && (wParam <= 46h)
			jmp Break

		.elseif (wParam >= 30h) && (wParam <= 39h)
			jmp Break

		.elseif wParam == 8	;Backspace
			jmp Break

		.endif
		
		mov eax, 0
		ret
		
	.endif

Break:
	invoke CallWindowProc, pOldEditProc, hWnd, uMsg, wParam, lParam

	ret

SubclassEdit endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SubClassDialog proc, hWnd: dword, uMsg: dword, wParam: dword, lParam: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	temp: 	dword

	.if uMsg == WM_NOTIFY

	  mov ecx, lParam
	  assume ecx: ptr NMLVCUSTOMDRAW
	 
		.if [ecx].nmcd.hdr.code == NM_CUSTOMDRAW

		    .if [ecx].nmcd.dwDrawStage == CDDS_PREPAINT

		       mov eax, CDRF_NOTIFYITEMDRAW
		       ret

		    .elseif [ecx].nmcd.dwDrawStage == CDDS_ITEMPREPAINT

				mov eax, CDRF_NOTIFYSUBITEMDRAW 
				ret
		    .elseif [ecx].nmcd.dwDrawStage ==  CDDS_ITEMPREPAINT or CDDS_SUBITEM

			mov eax, SubItemToFlash
			mov edx, ItemToFlash 

			.if ([ecx].nmcd.dwItemSpec == edx) && ([ecx].iSubItem == eax)
				mov [ecx].clrTextBk, FlashColor
				mov eax, CDRF_NEWFONT
				ret
			.else
				mov [ecx].clrTextBk, UnFlashColor
				mov eax, CDRF_NEWFONT
				ret
			     
			.endif
		    .endif
		.endif

		mov eax, 0
		ret

	.endif

	invoke CallWindowProc, pOldDialogProc, hWnd, uMsg, wParam, lParam
	ret

SubClassDialog endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	MakeColumn	proc, hlistview: dword, Index: dword, _Width: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local lvcolumn:		LV_COLUMN

	mov eax, _Width
	mov lvcolumn.lx, eax
	mov lvcolumn.imask, LVCF_WIDTH
	invoke SendMessage, hlistview, LVM_INSERTCOLUMN, Index, addr lvcolumn
	;returns index of column or -1 on error
	ret

MakeColumn endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	CreateList	proc, _Rows: dword, _Columns: dword, _ColumnWidth: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	lvitem:	LV_ITEM


	invoke MakeColumn, hListView, 0, 0	;hide all items
	invoke MakeColumn, hListView, 1, 75	;column for addresses

	mov ecx, 2

   .while ecx <= _Columns
	push ecx
	invoke MakeColumn, hListView, ecx, _ColumnWidth
	pop ecx
	inc ecx
   .endw

	invoke MakeColumn, hListView, ecx, 200	;column for ASCII Dump

	mov lvitem.imask, 0
	mov lvitem.iSubItem, 0
	xor ecx, ecx

   .repeat	
	mov lvitem.iItem, ecx
	push ecx
	invoke SendMessage, hListView, LVM_INSERTITEM, 0, addr lvitem
	pop ecx
	inc ecx
   .until ecx == _Rows

	ret

CreateList endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FillList proc, SourceAddress: dword, DisplayAddress: dword,  _Rows: dword, \
		_Columns: dword, Blank: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	lvitem:		LV_ITEM
	local 	CurrentRow:	dword
	local	CurrentColumn:	dword

;---- SubItem 0 = hidden   SubItem 1 = address	Subitems 2-17 bytes ----
 
	mov CurrentRow, 0
	mov TextBuffer, 0
	mov lvitem.imask, LVIF_TEXT

.repeat
	mov eax, CurrentRow
	mov lvitem.iItem, eax

;--- Set address Field for this row ---
	invoke wsprintf, addr TextBuffer, SADD ("%08X"), DisplayAddress
	mov lvitem.iSubItem, 1
	mov lvitem.pszText, offset TextBuffer
	invoke SendMessage, hListView, LVM_SETITEM, 0, addr lvitem

	mov CurrentColumn, 2
	
;--- Do one row ---
        .repeat		
		mov eax, CurrentColumn
		mov lvitem.iSubItem, eax
		mov esi, SourceAddress
		xor ecx, ecx
		.if Blank == FALSE
			mov cl, byte ptr [esi]
			invoke wsprintf, addr TextBuffer, SADD ("%02X"), ecx			
			mov lvitem.pszText, offset TextBuffer
		.else
			mov lvitem.pszText, offset (literal ("--"))
		.endif

		invoke SendMessage, hListView, LVM_SETITEM, 0, addr lvitem
		inc SourceAddress
		inc CurrentColumn
		mov eax, CurrentColumn
	.until eax > _Columns

;---- Create ASCII dump of last row displayed ----
   
	mov esi, SourceAddress
	sub esi, Columns-1		;pointer to start of row in memory
	mov edi, offset TextBuffer
	mov ecx, Columns-1
	mov lvitem.pszText, offset TextBuffer	

;---- copy to TextBuffer----
CopyText:
    .if Blank == FALSE

	mov al, [esi]
	
	  .if (al > 1fh) && (al < 7bh) 
		mov [edi], al
	  .else 
		mov byte ptr [edi], "."
	  .endif

    .else

	mov byte ptr [edi], "."

    .endif

	inc esi
	inc edi	
	loop CopyText
;---------------------------

	mov byte ptr [edi], 0	;trailing NULL

	mov eax, CurrentColumn
	mov lvitem.iSubItem, eax	;tail end column
	invoke SendMessage, hListView, LVM_SETITEM, 0, addr lvitem
   
	inc CurrentRow
	mov eax, CurrentRow
	add DisplayAddress, Columns-1
.until eax > _Rows

	ret	

FillList endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	MapAndRead	proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	BytesRet:	dword

	;---- Map view of Phys Memory ----
	invoke DeviceIoControl, hMemPhys, IOCTL_CHANGEPTE, addr NewPTE, 8, addr OldPTE, \
					8, addr BytesRet, NULL

	;---- copy data from Heap to process data section ----
		mov ecx, 4096 / (sizeof dword)
		mov esi, pHeap
		mov edi, offset MemBuffer
		cld
		rep movsd
				
	;---- UnMap view of Phys Memory ----
		invoke DeviceIoControl, hMemPhys, IOCTL_CHANGEPTE, addr OldPTE, 8, addr NewPTE, \
			8, addr BytesRet, NULL

	;---- Display data in ListView ----
		invoke FillList, addr MemBuffer, NewPTE.Physical, Rows, Columns, FALSE

	;---- Read was valid so write can be enabled ----
		invoke EnableWindow, hWrite, TRUE
		ret

MapAndRead endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	MapAndWrite	proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	BytesRet:	dword

	;---- Map view of Phys Memory ----
	invoke DeviceIoControl, hMemPhys, IOCTL_CHANGEPTE, addr NewPTE, 8, addr OldPTE, \
					8, addr BytesRet, NULL

	;---- copy data from process data section to Heap ----
		mov ecx, 4096 / (sizeof dword)
		mov edi, pHeap
		mov esi, offset MemBuffer
		cld
		rep movsd
				
	;---- UnMap view of Phys Memory ----
		invoke DeviceIoControl, hMemPhys, IOCTL_CHANGEPTE, addr OldPTE, 8, addr NewPTE, \
			8, addr BytesRet, NULL

		ret

MapAndWrite endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	EditMemory	proc, Address: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	mov FlashSubItem, FALSE	;disable opening further editing boxes
					;until this edit is finished
	invoke GetModuleHandle, NULL
	invoke DialogBoxParam, eax, IDD_DIALOGEDIT, NULL, addr DlgProc2, Address
	mov FlashSubItem, TRUE
	ret

EditMemory endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DlgProc2 proc, hWnd: dword, uMsg: dword, wParam: dword, lParam: dword
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	.if uMsg == WM_INITDIALOG

		;---- Subclass Edit Controls ----
		invoke GetDlgItem, hWnd, IDC_EditEdit
		mov hEditEdit, eax
		invoke SetWindowLong, eax, GWL_WNDPROC, addr SubclassEdit

		;---- Display address being edited in title bar ----
		mov eax, lParam
		mov pMemtoEdit, eax
		sub eax, offset MemBuffer
		add eax, NewPTE.Physical
		invoke wsprintf, addr TextBuffer, SADD ("%08X"), eax
		invoke SetWindowText, hWnd, addr TextBuffer
	
		;---- Display current value of address in edit box ----
		mov eax, lParam
		mov al, [eax]
		and eax, 0ffh
		invoke wsprintf, addr TextBuffer, SADD ("%02X"), eax	
		invoke SetWindowText, hEditEdit, addr TextBuffer

		;--- Highlight default text entry ----
		invoke SetFocus, hEditEdit
		invoke SendMessage, hEditEdit, WM_LBUTTONDBLCLK, 0, 0

		mov eax, FALSE	
		ret

	.elseif uMsg == WM_COMMAND
		mov eax, wParam	
		.if ax == IDB_OK
			invoke GetWindowText, hEditEdit, addr TextBuffer, 256
			invoke htodw, addr TextBuffer
			mov ecx, pMemtoEdit
			mov [ecx], al
			invoke FillList, addr MemBuffer, NewPTE.Physical, Rows, Columns, FALSE
			
			invoke EndDialog, hWnd, NULL
			mov eax, TRUE
			ret

		.elseif ax == IDB_CANCEL
			invoke EndDialog, hWnd, NULL
			mov eax, TRUE
			ret
		.endif
	.endif

	mov eax, FALSE
	ret
	
DlgProc2 endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	htodw proc String:DWORD
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


  ;Taken from the MASM package LIB
  ;Author Unknown


  ; -----------------------------------
  ; Convert hex string into dword value
  ; Return value in eax
  ; -----------------------------------

    push ebx
    push esi
    push edi

    mov edi, String
    mov esi, String 

     ALIGN 4

  again:  
    mov al,[edi]
    inc edi
    or  al,al
    jnz again
    sub esi,edi
    xor ebx,ebx
    add edi,esi
    xor edx,edx
    not esi             ;esi = lenth

  .while esi != 0
    mov al, [edi]
    cmp al,'A'
    jb figure
    sub al,'a'-10
    adc dl,0
    shl dl,5            ;if cf set we get it bl 20h else - 0
    add al,dl
    jmp next
  figure: 
    sub al,'0'
  next:  
    lea ecx,[esi-1]
    and eax, 0Fh
    shl ecx,2           ;mul ecx by log 16(2)
    shl eax,cl          ;eax * 2^ecx
    add ebx, eax
    inc edi
    dec esi
  .endw

    mov eax,ebx

    pop edi
    pop esi
    pop ebx

    ret

htodw endp


.data

	szBinaryName		db	"\MemPhys.sys",NULL

.data?

	szBinaryPathname	db	512	dup	(?)
	szErrorMsg		db	512	dup	(?)
.code


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	InstallDriver		proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	hSCM:		dword
	local	hService: 	dword
	local	status:		dword

InstallerBegin:

	;==== Get path for MemPhys.sys ====
	invoke GetCurrentDirectory, 1024, addr szBinaryPathname
	invoke lstrcat, addr szBinaryPathname, addr szBinaryName

	;==== Install Driver ====
	invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS	
	mov hSCM, eax

     invoke CreateService, hSCM, SADD ("MemPhys"), SADD ("Physical Memory Viewer"),\				
	SERVICE_START or SERVICE_STOP or DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START,\		
	 SERVICE_ERROR_IGNORE, addr szBinaryPathname, NULL, NULL, NULL,\ 				
	 NULL, NULL				

	.if !eax
	
		invoke GetLastError

		.if eax == ERROR_SERVICE_EXISTS
			invoke CloseServiceHandle, hSCM
			invoke RemoveDriver
			jmp InstallerBegin
		.endif

		invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, eax, \
		 NULL, addr szErrorMsg, 1024, NULL
		invoke MessageBox, NULL, addr szErrorMsg, SADD ("CreateService Failed"),\
			 MB_ICONSTOP 
		mov status, -1
		jmp Exit
	.else
		mov status, 0
	.endif
	
	mov hService, eax

	invoke StartService, hService, NULL, NULL

	.if !eax
		invoke DeleteService, hService
		invoke GetLastError
		invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, eax, \
		 NULL, addr szErrorMsg, 1024, NULL
		invoke MessageBox, NULL, addr szErrorMsg, SADD ("StartService Failed"),\
			 MB_ICONSTOP 
		mov status, -1
	.endif

	invoke CloseServiceHandle, hService
Exit:
	invoke CloseServiceHandle, hSCM
	mov eax, status
	ret

InstallDriver endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	RemoveDriver		proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	local	hSCM:		dword
	local 	hService: 	dword
	local 	ServiceStatus:	SERVICE_STATUS
	local	status:		dword

	invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
	mov hSCM, eax
	invoke OpenService, hSCM, SADD ("MemPhys"), SERVICE_ALL_ACCESS

	.if !eax
		invoke MessageBox, NULL, SADD ("MemPhys not installed"),\
		SADD ("Error"), MB_ICONSTOP
		mov status, -1
		jmp Exit
	.endif

	mov hService, eax
	
	;=== Service is installed ===
	invoke ControlService, hService, SERVICE_CONTROL_STOP, addr ServiceStatus
	invoke DeleteService, hService
	
	.if eax
		mov status, 0
		
	.else
		invoke MessageBox, NULL, SADD ("DeleteService Failed"), \
		 SADD ("Error"), MB_ICONSTOP
		mov status, -1
	.endif

	invoke CloseServiceHandle, hService
Exit:
	invoke CloseServiceHandle, hSCM
	mov eax, status
	ret

RemoveDriver endp

;~~~~~~~~~~~~~~
end EntryPoint
;~~~~~~~~~~~~~~


	